// Copyright (c) 2024 Giorgos Vougioukas
//
// The license can be found in the LICENSE file.

#ifndef _MARKELLA_FIND_WND_H_
#define _MARKELLA_FIND_WND_H_

#include "definitions.h"

class MAR_FindWnd
{
public:
  MAR_FindWnd();
  ~MAR_FindWnd();

  HWND Handle() const;

  static WDL_DLGRET FindWndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
private:
  void OnInitDialog(WPARAM wparam, LPARAM lparam);
  INT_PTR OnClose(WPARAM wparam, LPARAM lparam);
  void OnDestroy(WPARAM wparam, LPARAM lparam);
  void OnSysCommand(WPARAM wparam, LPARAM lparam);
  void OnCommand(WPARAM wparam, LPARAM lparam);
  WDL_DLGRET FindWndLoop(UINT msg, WPARAM wparam, LPARAM lparam);

  HWND m_hwnd;
  HWND m_find;
  HWND m_matchcase;
  HWND m_matchword;
};

#endif // _MARKELLA_FIND_WND_H_
